Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -4558,140 +4472,142 @@
 !--  Read building surface pars. If present, they override LOD1-LOD3 building pars where applicable
      IF ( building_surface_pars_f%from_file )  THEN
-        DO  m = 1, surf_usm_h%ns
-           i = surf_usm_h%i(m)
-           j = surf_usm_h%j(m)
-           k = surf_usm_h%k(m)
-!
-!--        Iterate over surfaces in column, check height and orientation
-           DO  is = building_surface_pars_f%index_ji(1,j,i), &
-                    building_surface_pars_f%index_ji(2,j,i)
-              IF ( building_surface_pars_f%coords(4,is) == -surf_usm_h%koff .AND.                  &
-                   building_surface_pars_f%coords(1,is) == k )  THEN
-
-                 IF ( building_surface_pars_f%pars(ind_s_wall_frac,is) /=                          &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%frac(m,ind_veg_wall) =                                              &
-                    building_surface_pars_f%pars(ind_s_wall_frac,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_green_frac_w,is) /=                       &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%frac(m,ind_pav_green) =                                             &
-                    building_surface_pars_f%pars(ind_s_green_frac_w,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_green_frac_r,is) /=                       &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%frac(m,ind_pav_green) =                                             &
-                    building_surface_pars_f%pars(ind_s_green_frac_r,is)
-                    !TODO clarify: why should _w and _r be on the same surface?
-
-                 IF ( building_surface_pars_f%pars(ind_s_win_frac,is) /=                           &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%frac(m,ind_wat_win) = building_surface_pars_f%pars(ind_s_win_frac,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_lai_r,is) /=                              &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%lai(m) = building_surface_pars_f%pars(ind_s_lai_r,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_hc1,is) /=                                &
-                      building_surface_pars_f%fill )  THEN
-                    surf_usm_h%rho_c_wall(nzb_wall:nzb_wall+1,m) =                                 &
-                    building_surface_pars_f%pars(ind_s_hc1,is)
-                    surf_usm_h%rho_c_green(nzb_wall:nzb_wall+1,m) =                                &
-                    building_surface_pars_f%pars(ind_s_hc1,is)
-                    surf_usm_h%rho_c_window(nzb_wall:nzb_wall+1,m) =                               &
-                    building_surface_pars_f%pars(ind_s_hc1,is)
+        DO  l = 0, 1
+           DO  m = 1, surf_usm_h(l)%ns
+              i = surf_usm_h(l)%i(m)
+              j = surf_usm_h(l)%j(m)
+              k = surf_usm_h(l)%k(m)
+!
+!--           Iterate over surfaces in column, check height and orientation
+              DO  is = building_surface_pars_f%index_ji(1,j,i), &
+                       building_surface_pars_f%index_ji(2,j,i)
+                 IF ( building_surface_pars_f%coords(4,is) == -surf_usm_h(l)%koff .AND.               &
+                      building_surface_pars_f%coords(1,is) == k )  THEN
+
+                    IF ( building_surface_pars_f%pars(ind_s_wall_frac,is) /=                          &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%frac(m,ind_veg_wall) =                                           &
+                       building_surface_pars_f%pars(ind_s_wall_frac,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_green_frac_w,is) /=                       &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%frac(m,ind_pav_green) =                                          &
+                       building_surface_pars_f%pars(ind_s_green_frac_w,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_green_frac_r,is) /=                       &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%frac(m,ind_pav_green) =                                          &
+                       building_surface_pars_f%pars(ind_s_green_frac_r,is)
+                       !TODO clarify: why should _w and _r be on the same surface?
+
+                    IF ( building_surface_pars_f%pars(ind_s_win_frac,is) /=                           &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%frac(m,ind_wat_win) = building_surface_pars_f%pars(ind_s_win_frac,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_lai_r,is) /=                              &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%lai(m) = building_surface_pars_f%pars(ind_s_lai_r,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_hc1,is) /=                                &
+                         building_surface_pars_f%fill )  THEN
+                       surf_usm_h(l)%rho_c_wall(nzb_wall:nzb_wall+1,m) =                              &
+                       building_surface_pars_f%pars(ind_s_hc1,is)
+                       surf_usm_h(l)%rho_c_green(nzb_wall:nzb_wall+1,m) =                             &
+                       building_surface_pars_f%pars(ind_s_hc1,is)
+                       surf_usm_h(l)%rho_c_window(nzb_wall:nzb_wall+1,m) =                            &
+                       building_surface_pars_f%pars(ind_s_hc1,is)
+                    ENDIF
+
+                    IF ( building_surface_pars_f%pars(ind_s_hc2,is) /=                                &
+                         building_surface_pars_f%fill )  THEN
+                       surf_usm_h(l)%rho_c_wall(nzb_wall+2,m) =                                       &
+                       building_surface_pars_f%pars(ind_s_hc2,is)
+                       surf_usm_h(l)%rho_c_green(nzb_wall+2,m) =                                      &
+                       building_surface_pars_f%pars(ind_s_hc2,is)
+                       surf_usm_h(l)%rho_c_window(nzb_wall+2,m) =                                     &
+                       building_surface_pars_f%pars(ind_s_hc2,is)
+                    ENDIF
+
+                    IF ( building_surface_pars_f%pars(ind_s_hc3,is) /=                                &
+                         building_surface_pars_f%fill )  THEN
+                       surf_usm_h(l)%rho_c_wall(nzb_wall+3,m) =                                       &
+                       building_surface_pars_f%pars(ind_s_hc3,is)
+                       surf_usm_h(l)%rho_c_green(nzb_wall+3,m) =                                      &
+                       building_surface_pars_f%pars(ind_s_hc3,is)
+                       surf_usm_h(l)%rho_c_window(nzb_wall+3,m) =                                     &
+                       building_surface_pars_f%pars(ind_s_hc3,is)
+                    ENDIF
+
+                    IF ( building_surface_pars_f%pars(ind_s_tc1,is) /=                                &
+                         building_surface_pars_f%fill )  THEN
+                       surf_usm_h(l)%lambda_h(nzb_wall:nzb_wall+1,m) =                                &
+                       building_surface_pars_f%pars(ind_s_tc1,is)
+                       surf_usm_h(l)%lambda_h_green(nzb_wall:nzb_wall+1,m) =                          &
+                       building_surface_pars_f%pars(ind_s_tc1,is)
+                       surf_usm_h(l)%lambda_h_window(nzb_wall:nzb_wall+1,m) =                         &
+                       building_surface_pars_f%pars(ind_s_tc1,is)
+                    ENDIF
+
+                    IF ( building_surface_pars_f%pars(ind_s_tc2,is) /=                                &
+                         building_surface_pars_f%fill )  THEN
+                       surf_usm_h(l)%lambda_h(nzb_wall+2,m) =                                         &
+                       building_surface_pars_f%pars(ind_s_tc2,is)
+                       surf_usm_h(l)%lambda_h_green(nzb_wall+2,m) =                                   &
+                       building_surface_pars_f%pars(ind_s_tc2,is)
+                       surf_usm_h(l)%lambda_h_window(nzb_wall+2,m) =                                  &
+                       building_surface_pars_f%pars(ind_s_tc2,is)
+                    ENDIF
+
+                    IF ( building_surface_pars_f%pars(ind_s_tc3,is) /=                                &
+                         building_surface_pars_f%fill )  THEN
+                       surf_usm_h(l)%lambda_h(nzb_wall+3,m) =                                         &
+                       building_surface_pars_f%pars(ind_s_tc3,is)
+                       surf_usm_h(l)%lambda_h_green(nzb_wall+3,m) =                                   &
+                       building_surface_pars_f%pars(ind_s_tc3,is)
+                       surf_usm_h(l)%lambda_h_window(nzb_wall+3,m) =                                  &
+                       building_surface_pars_f%pars(ind_s_tc3,is)
+                    ENDIF
+
+                    IF ( building_surface_pars_f%pars(ind_s_indoor_target_temp_summer,is) /=          &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%target_temp_summer(m) =                                          &
+                       building_surface_pars_f%pars(ind_s_indoor_target_temp_summer,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_indoor_target_temp_winter,is) /=          &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%target_temp_winter(m) =                                          &
+                       building_surface_pars_f%pars(ind_s_indoor_target_temp_winter,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_emis_wall,is) /=                          &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%emissivity(m,ind_veg_wall) =                                     &
+                       building_surface_pars_f%pars(ind_s_emis_wall,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_emis_green,is) /=                         &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%emissivity(m,ind_pav_green) =                                    &
+                       building_surface_pars_f%pars(ind_s_emis_green,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_emis_win,is) /=                           &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%emissivity(m,ind_wat_win) =                                      &
+                       building_surface_pars_f%pars(ind_s_emis_win,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_trans,is) /=                              &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%transmissivity(m) = building_surface_pars_f%pars(ind_s_trans,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_z0,is) /=                                 &
+                         building_surface_pars_f%fill )                                               &
+                       surf_usm_h(l)%z0(m) = building_surface_pars_f%pars(ind_s_z0,is)
+
+                    IF ( building_surface_pars_f%pars(ind_s_z0qh,is) /=                               &
+                         building_surface_pars_f%fill )  THEN
+                       surf_usm_h(l)%z0q(m) = building_surface_pars_f%pars(ind_s_z0qh,is)
+                       surf_usm_h(l)%z0h(m) = building_surface_pars_f%pars(ind_s_z0qh,is)
+                    ENDIF
+
+                    EXIT ! Surface was found and processed
                  ENDIF
-
-                 IF ( building_surface_pars_f%pars(ind_s_hc2,is) /=                                &
-                      building_surface_pars_f%fill )  THEN
-                    surf_usm_h%rho_c_wall(nzb_wall+2,m) =                                          &
-                    building_surface_pars_f%pars(ind_s_hc2,is)
-                    surf_usm_h%rho_c_green(nzb_wall+2,m) =                                         &
-                    building_surface_pars_f%pars(ind_s_hc2,is)
-                    surf_usm_h%rho_c_window(nzb_wall+2,m) =                                        &
-                    building_surface_pars_f%pars(ind_s_hc2,is)
-                 ENDIF
-
-                 IF ( building_surface_pars_f%pars(ind_s_hc3,is) /=                                &
-                      building_surface_pars_f%fill )  THEN
-                    surf_usm_h%rho_c_wall(nzb_wall+3,m) =                                          &
-                    building_surface_pars_f%pars(ind_s_hc3,is)
-                    surf_usm_h%rho_c_green(nzb_wall+3,m) =                                         &
-                    building_surface_pars_f%pars(ind_s_hc3,is)
-                    surf_usm_h%rho_c_window(nzb_wall+3,m) =                                        &
-                    building_surface_pars_f%pars(ind_s_hc3,is)
-                 ENDIF
-
-                 IF ( building_surface_pars_f%pars(ind_s_tc1,is) /=                                &
-                      building_surface_pars_f%fill )  THEN
-                    surf_usm_h%lambda_h(nzb_wall:nzb_wall+1,m) =                                   &
-                    building_surface_pars_f%pars(ind_s_tc1,is)
-                    surf_usm_h%lambda_h_green(nzb_wall:nzb_wall+1,m) =                             &
-                    building_surface_pars_f%pars(ind_s_tc1,is)
-                    surf_usm_h%lambda_h_window(nzb_wall:nzb_wall+1,m) =                            &
-                    building_surface_pars_f%pars(ind_s_tc1,is)
-                 ENDIF
-
-                 IF ( building_surface_pars_f%pars(ind_s_tc2,is) /=                                &
-                      building_surface_pars_f%fill )  THEN
-                    surf_usm_h%lambda_h(nzb_wall+2,m) =                                            &
-                    building_surface_pars_f%pars(ind_s_tc2,is)
-                    surf_usm_h%lambda_h_green(nzb_wall+2,m) =                                      &
-                    building_surface_pars_f%pars(ind_s_tc2,is)
-                    surf_usm_h%lambda_h_window(nzb_wall+2,m) =                                     &
-                    building_surface_pars_f%pars(ind_s_tc2,is)
-                 ENDIF
-
-                 IF ( building_surface_pars_f%pars(ind_s_tc3,is) /=                                &
-                      building_surface_pars_f%fill )  THEN
-                    surf_usm_h%lambda_h(nzb_wall+3,m) =                                            &
-                    building_surface_pars_f%pars(ind_s_tc3,is)
-                    surf_usm_h%lambda_h_green(nzb_wall+3,m) =                                      &
-                    building_surface_pars_f%pars(ind_s_tc3,is)
-                    surf_usm_h%lambda_h_window(nzb_wall+3,m) =                                     &
-                    building_surface_pars_f%pars(ind_s_tc3,is)
-                 ENDIF
-
-                 IF ( building_surface_pars_f%pars(ind_s_indoor_target_temp_summer,is) /=          &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%target_temp_summer(m) =                                             &
-                    building_surface_pars_f%pars(ind_s_indoor_target_temp_summer,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_indoor_target_temp_winter,is) /=          &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%target_temp_winter(m) =                                             &
-                    building_surface_pars_f%pars(ind_s_indoor_target_temp_winter,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_emis_wall,is) /=                          &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%emissivity(m,ind_veg_wall) =                                        &
-                    building_surface_pars_f%pars(ind_s_emis_wall,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_emis_green,is) /=                         &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%emissivity(m,ind_pav_green) =                                       &
-                    building_surface_pars_f%pars(ind_s_emis_green,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_emis_win,is) /=                           &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%emissivity(m,ind_wat_win) =                                         &
-                    building_surface_pars_f%pars(ind_s_emis_win,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_trans,is) /=                              &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%transmissivity(m) = building_surface_pars_f%pars(ind_s_trans,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_z0,is) /=                                 &
-                      building_surface_pars_f%fill )                                               &
-                    surf_usm_h%z0(m) = building_surface_pars_f%pars(ind_s_z0,is)
-
-                 IF ( building_surface_pars_f%pars(ind_s_z0qh,is) /=                               &
-                      building_surface_pars_f%fill )  THEN
-                    surf_usm_h%z0q(m) = building_surface_pars_f%pars(ind_s_z0qh,is)
-                    surf_usm_h%z0h(m) = building_surface_pars_f%pars(ind_s_z0qh,is)
-                 ENDIF
-
-                 EXIT ! Surface was found and processed
-              ENDIF
+              ENDDO
            ENDDO
         ENDDO
@@ -4842,44 +4758,47 @@
      ENDIF
 !
-!--    Initialize albedo type via given type from static input file. Please note, even though
-!--    the albedo type has been already given by the pars, albedo_type overwrites these values.
-       IF ( albedo_type_f%from_file )  THEN
-          DO  m = 1, surf_usm_h%ns
-             i = surf_usm_h%i(m)
-             j = surf_usm_h%j(m)
-             IF ( albedo_type_f%var(j,i) /= albedo_type_f%fill )                                   &
-                surf_usm_h%albedo_type(m,:) = albedo_type_f%var(j,i)
-          ENDDO
-          DO  l = 0, 3
-             DO  m = 1, surf_usm_v(l)%ns
-                i = surf_usm_v(l)%i(m) + surf_usm_v(l)%ioff
-                j = surf_usm_v(l)%j(m) + surf_usm_v(l)%joff
-
-                IF ( albedo_type_f%var(j,i) /= albedo_type_f%fill )                                &
-                   surf_usm_v(l)%albedo_type(m,:) = albedo_type_f%var(j,i)
-             ENDDO
-          ENDDO
-       ENDIF
+!--  Initialize albedo type via given type from static input file. Please note, even though
+!--  the albedo type has been already given by the pars, albedo_type overwrites these values.
+     IF ( albedo_type_f%from_file )  THEN
+        DO  l = 0, 1
+           DO  m = 1, surf_usm_h(l)%ns
+              i = surf_usm_h(l)%i(m)
+              j = surf_usm_h(l)%j(m)
+              IF ( albedo_type_f%var(j,i) /= albedo_type_f%fill )                               &
+                 surf_usm_h(l)%albedo_type(m,:) = albedo_type_f%var(j,i)
+           ENDDO
+        ENDDO
+        DO  l = 0, 3
+           DO  m = 1, surf_usm_v(l)%ns
+              i = surf_usm_v(l)%i(m) + surf_usm_v(l)%ioff
+              j = surf_usm_v(l)%j(m) + surf_usm_v(l)%joff
+             IF ( albedo_type_f%var(j,i) /= albedo_type_f%fill )                                &
+                 surf_usm_v(l)%albedo_type(m,:) = albedo_type_f%var(j,i)
+           ENDDO
+        ENDDO
+     ENDIF
 !
 !--  Run further checks to ensure that the respecitve material fractions are prescribed properly.
 !--  Start with horizontal surfaces (roofs).
      relative_fractions_corrected = .FALSE.
-     DO  m = 1, surf_usm_h%ns
-        sum_frac = SUM( surf_usm_h%frac(m,:) )
-        IF ( sum_frac /= 1.0_wp )  THEN
-           relative_fractions_corrected = .TRUE.
-!
-!--        Normalize relative fractions to 1. Deviations from 1 can arise, e.g. by rounding errors
-!--        but also by inconsistent driver creation.
-           IF ( sum_frac /= 0.0_wp )  THEN
-              surf_usm_h%frac(m,:) = surf_usm_h%frac(m,:) / sum_frac
-!
-!--        In case all relative fractions are erroneously set to zero, set wall fraction to 1.
-           ELSE
-              surf_usm_h%frac(m,ind_veg_wall)  = 1.0_wp
-              surf_usm_h%frac(m,ind_wat_win)   = 0.0_wp
-              surf_usm_h%frac(m,ind_pav_green) = 0.0_wp
+     DO  l = 0, 1
+        DO  m = 1, surf_usm_h(l)%ns
+           sum_frac = SUM( surf_usm_h(l)%frac(m,:) )
+           IF ( sum_frac /= 1.0_wp )  THEN
+              relative_fractions_corrected = .TRUE.
+!
+!--           Normalize relative fractions to 1. Deviations from 1 can arise, e.g. by rounding errors
+!--           but also by inconsistent driver creation.
+              IF ( sum_frac /= 0.0_wp )  THEN
+                 surf_usm_h(l)%frac(m,:) = surf_usm_h(l)%frac(m,:) / sum_frac
+!
+!--           In case all relative fractions are erroneously set to zero, set wall fraction to 1.
+              ELSE
+                 surf_usm_h(l)%frac(m,ind_veg_wall)  = 1.0_wp
+                 surf_usm_h(l)%frac(m,ind_wat_win)   = 0.0_wp
+                 surf_usm_h(l)%frac(m,ind_pav_green) = 0.0_wp
+              ENDIF
            ENDIF
-        ENDIF
+        ENDDO
      ENDDO
 !
@@ -4928,30 +4847,26 @@
      ENDIF
 !
-!--  Read the surface_types array.
-!--  Please note, here also initialization of surface attributes is done as long as _urbsurf and
-!--  _surfpar files are available. Values from above will be overwritten. This might be removed
-!--  later, but is still in the code to enable compatibility with older model version.
-     CALL usm_read_urban_surface_types()
-
-     CALL usm_init_material_model()
+!--  Initialization of the wall/roof materials
+     CALL usm_init_wall_heat_model()
 
 !--  Init skin layer properties (can be done after initialization of wall layers)
-
-     DO  m = 1, surf_usm_h%ns
-        i = surf_usm_h%i(m)
-        j = surf_usm_h%j(m)
-
-         surf_usm_h%c_surface(m)           = surf_usm_h%rho_c_wall(nzb_wall,m) *                   &
-                                             surf_usm_h%dz_wall(nzb_wall,m) * 0.25_wp
-         surf_usm_h%lambda_surf(m)         = surf_usm_h%lambda_h(nzb_wall,m) *                     &
-                                             surf_usm_h%ddz_wall(nzb_wall,m) * 2.0_wp
-         surf_usm_h%c_surface_green(m)     = surf_usm_h%rho_c_wall(nzb_wall,m) *                   &
-                                             surf_usm_h%dz_wall(nzb_wall,m) * 0.25_wp
-         surf_usm_h%lambda_surf_green(m)   = surf_usm_h%lambda_h_green(nzb_wall,m) *               &
-                                             surf_usm_h%ddz_green(nzb_wall,m) * 2.0_wp
-         surf_usm_h%c_surface_window(m)    = surf_usm_h%rho_c_window(nzb_wall,m) *                 &
-                                             surf_usm_h%dz_window(nzb_wall,m) * 0.25_wp
-         surf_usm_h%lambda_surf_window(m)  = surf_usm_h%lambda_h_window(nzb_wall,m) *              &
-                                             surf_usm_h%ddz_window(nzb_wall,m) * 2.0_wp
+     DO  l = 0, 1
+        DO  m = 1, surf_usm_h(l)%ns
+           i = surf_usm_h(l)%i(m)
+           j = surf_usm_h(l)%j(m)
+
+            surf_usm_h(l)%c_surface(m)           = surf_usm_h(l)%rho_c_wall(nzb_wall,m) *          &
+                                                surf_usm_h(l)%dz_wall(nzb_wall,m) * 0.25_wp
+            surf_usm_h(l)%lambda_surf(m)         = surf_usm_h(l)%lambda_h(nzb_wall,m) *            &
+                                                surf_usm_h(l)%ddz_wall(nzb_wall,m) * 2.0_wp
+            surf_usm_h(l)%c_surface_green(m)     = surf_usm_h(l)%rho_c_wall(nzb_wall,m) *          &
+                                                surf_usm_h(l)%dz_wall(nzb_wall,m) * 0.25_wp
+            surf_usm_h(l)%lambda_surf_green(m)   = surf_usm_h(l)%lambda_h_green(nzb_wall,m) *      &
+                                                surf_usm_h(l)%ddz_green(nzb_wall,m) * 2.0_wp
+            surf_usm_h(l)%c_surface_window(m)    = surf_usm_h(l)%rho_c_window(nzb_wall,m) *        &
+                                                surf_usm_h(l)%dz_window(nzb_wall,m) * 0.25_wp
+            surf_usm_h(l)%lambda_surf_window(m)  = surf_usm_h(l)%lambda_h_window(nzb_wall,m) *     &
+                                                surf_usm_h(l)%ddz_window(nzb_wall,m) * 2.0_wp
+        ENDDO
      ENDDO
 
@@ -4977,35 +4892,29 @@
 
 !
-!--  Init anthropogenic sources of heat
-     IF ( usm_anthropogenic_heat )  THEN
-!
-!--      Init anthropogenic sources of heat (from transportation for now)
-         CALL usm_read_anthropogenic_heat()
-     ENDIF
-
-!
 !-- Check for consistent initialization.
 !-- Check if roughness length for momentum, or heat, exceed surface-layer height and decrease local
 !-- roughness length where necessary.
-    DO  m = 1, surf_usm_h%ns
-       IF ( surf_usm_h%z0(m) >= surf_usm_h%z_mo(m) )  THEN
-
-          surf_usm_h%z0(m) = 0.9_wp * surf_usm_h%z_mo(m)
-
-          WRITE( message_string, * ) 'z0 exceeds surface-layer height at horizontal urban ' //     &
-                                     'surface and is decreased appropriately at grid point ' //    &
-                                     '(i,j) = ',  surf_usm_h%i(m), surf_usm_h%j(m)
-          CALL message( 'urban_surface_model_mod', 'PA0503', 0, 0, myid, 6, 0 )
-       ENDIF
-       IF ( surf_usm_h%z0h(m) >= surf_usm_h%z_mo(m) )  THEN
-
-          surf_usm_h%z0h(m) = 0.9_wp * surf_usm_h%z_mo(m)
-          surf_usm_h%z0q(m) = 0.9_wp * surf_usm_h%z_mo(m)
-
-          WRITE( message_string, * ) 'z0h exceeds surface-layer height at horizontal urban ' //    &
-                                     'surface and is decreased appropriately at grid point ' //    &
-                                     '(i,j) = ', surf_usm_h%i(m), surf_usm_h%j(m)
-          CALL message( 'urban_surface_model_mod', 'PA0507', 0, 0, myid, 6, 0 )
-       ENDIF
+    DO  l = 0, 1
+       DO  m = 1, surf_usm_h(l)%ns
+          IF ( surf_usm_h(l)%z0(m) >= surf_usm_h(l)%z_mo(m) )  THEN
+
+             surf_usm_h(l)%z0(m) = 0.9_wp * surf_usm_h(l)%z_mo(m)
+
+             WRITE( message_string, * ) 'z0 exceeds surface-layer height at horizontal urban ' //     &
+                                        'surface and is decreased appropriately at grid point ' //    &
+                                        '(i,j) = ',  surf_usm_h(l)%i(m), surf_usm_h(l)%j(m)
+             CALL message( 'urban_surface_model_mod', 'PA0503', 0, 0, myid, 6, 0 )
+          ENDIF
+          IF ( surf_usm_h(l)%z0h(m) >= surf_usm_h(l)%z_mo(m) )  THEN
+
+             surf_usm_h(l)%z0h(m) = 0.9_wp * surf_usm_h(l)%z_mo(m)
+             surf_usm_h(l)%z0q(m) = 0.9_wp * surf_usm_h(l)%z_mo(m)
+
+             WRITE( message_string, * ) 'z0h exceeds surface-layer height at horizontal urban ' //    &
+                                        'surface and is decreased appropriately at grid point ' //    &
+                                        '(i,j) = ', surf_usm_h(l)%i(m), surf_usm_h(l)%j(m)
+             CALL message( 'urban_surface_model_mod', 'PA0507', 0, 0, myid, 6, 0 )
+          ENDIF
+       ENDDO
     ENDDO
 
@@ -5044,13 +4953,15 @@
 !--     At horizontal surfaces. Please note, t_surf_wall_h is defined on a different data type,
 !--     but with the same dimension.
-         DO  m = 1, surf_usm_h%ns
-            i = surf_usm_h%i(m)
-            j = surf_usm_h%j(m)
-            k = surf_usm_h%k(m)
-
-            t_surf_wall_h(m) = pt(k,j,i) * exner(k)
-            t_surf_window_h(m) = pt(k,j,i) * exner(k)
-            t_surf_green_h(m) = pt(k,j,i) * exner(k)
-            surf_usm_h%pt_surface(m) = pt(k,j,i) * exner(k)
+         DO  l = 0, 1
+            DO  m = 1, surf_usm_h(l)%ns
+               i = surf_usm_h(l)%i(m)
+               j = surf_usm_h(l)%j(m)
+               k = surf_usm_h(l)%k(m)
+
+               t_surf_wall_h(l)%val(m) = pt(k,j,i) * exner(k)
+               t_surf_window_h(l)%val(m) = pt(k,j,i) * exner(k)
+               t_surf_green_h(l)%val(m) = pt(k,j,i) * exner(k)
+               surf_usm_h(l)%pt_surface(m) = pt(k,j,i) * exner(k)
+            ENDDO
          ENDDO
 !
@@ -5062,7 +4973,7 @@
                k = surf_usm_v(l)%k(m)
 
-               t_surf_wall_v(l)%t(m) = pt(k,j,i) * exner(k)
-               t_surf_window_v(l)%t(m) = pt(k,j,i) * exner(k)
-               t_surf_green_v(l)%t(m) = pt(k,j,i) * exner(k)
+               t_surf_wall_v(l)%val(m) = pt(k,j,i) * exner(k)
+               t_surf_window_v(l)%val(m) = pt(k,j,i) * exner(k)
+               t_surf_green_v(l)%val(m) = pt(k,j,i) * exner(k)
                surf_usm_v(l)%pt_surface(m) = pt(k,j,i) * exner(k)
             ENDDO
@@ -5073,6 +4984,8 @@
 !--      Note, at urban surfaces q_surface is initialized with 0.
          IF ( humidity )  THEN
-            DO  m = 1, surf_usm_h%ns
-               surf_usm_h%q_surface(m) = 0.0_wp
+            DO  l = 0, 1
+               DO  m = 1, surf_usm_h(l)%ns
+                  surf_usm_h(l)%q_surface(m) = 0.0_wp
+               ENDDO
             ENDDO
             DO  l = 0, 3
